#
# Configuration file read/write forBVTerm
#
import ConfigParser


class Config:
    cf = ConfigParser.RawConfigParser()
    def __init__(self,cfgFile):
        # default values
        self.port = 'COM0'
        self.baudrate = '9600'
        self.parity = 'N'
        self.dataBits = 1   # index of combo box
        self.stopBits = 0   # index of combo box
        self.outgoing = 0
        self.XonXoff = False
        self.RtsCts = False
        self.RTS = False
        self.DTR = False
        self.EOL = 0
        self.quiet = False
        self.echo = False
        self.escmode = 0
        # [tload]
        self.filename = ''
        self.upmname = ''
        self.start = 'cold tload'
        self.upmdup = '0'
        self.ffilename = ''
        # boot loader
        self.flashStart ='1d000000'
        self.flashSize = '256'
        self.bfileName =''
        self.verbose = ''
        self.eraseDelay = '2'
        #
        self.order = 1 # RGB order 0 = rgb, 1 = bgr
        #
        self.cfgFile = cfgFile
        try:
            f = open(self.cfgFile, 'r')
            f.close()
        except  IOError:
        # set up standard config file, create sections and head
            self.cf.add_section('Main')
            self.cf.set('Main', 'Info', 'ByVac config file for BVserial')
            self.cf.set('Main', 'Source', 'www.byvac.com')
            self.cf.add_section('Coms')
            self.cf.add_section('tload')
            self.cf.add_section('rgb')
            self.cf.add_section('boot')
            with open(self.cfgFile, 'wb') as configfile:
              self.cf.write(configfile)
            self.write()  # write fr next time
        else:
            self.cf.read(self.cfgFile)
            self.read()

    def write(self):
        self.cf.set('Coms','PortName',self.port)
        self.cf.set('Coms','BaudRate',self.baudrate)
        self.cf.set('Coms', 'Parity', self.parity)
        self.cf.set('Coms', 'DataBits', self.dataBits) # index of combo box
        self.cf.set('Coms', 'StopBits', self.stopBits) # index of combo box
        self.cf.set('Coms', 'OutGoing', self.outgoing)
        self.cf.set('Coms', 'XonXoff',self.XonXoff)
        self.cf.set('Coms', 'RtsCts', self.RtsCts)
        self.cf.set('Coms', 'RTS', self.RTS)
        self.cf.set('Coms', 'DTR', self.DTR) # normaqlly high
        self.cf.set('Coms', 'Endofline', self.EOL) # end of line 0..2
        self.cf.set('Coms', 'Quiet', self.quiet)
        self.cf.set('Coms', 'Echo', self.echo)
        self.cf.set('Coms', 'escMode', self.escmode)
        #
        self.cf.set('tload', 'filename', self.filename)
        self.cf.set('tload', 'start', self.start)
        self.cf.set('tload', 'upmname', self.upmname)
        self.cf.set('tload', 'upmdup', self.upmdup)
        self.cf.set('tload', 'ffilename', self.ffilename)
        #
        self.cf.set('rgb', 'order', self.order)
        with open(self.cfgFile, 'wb') as configfile:
             self.cf.write(configfile)
        #
        self.cf.set('boot', 'flashstart', self.flashStart)
        self.cf.set('boot', 'flashsize', self.flashSize)
        self.cf.set('boot', 'bfilename', self.bfileName)
        self.cf.set('boot', 'verbose', self.verbose)
        self.cf.set('boot', 'erase', self.eraseDelay)

    def read(self):
        self.port = self.cf.get('Coms', 'PortName')
        self.baudrate = self.cf.get('Coms', 'BaudRate')
        self.parity = self.cf.get('Coms', 'Parity')
        self.dataBits = int(self.cf.get('Coms', 'DataBits')) # index of combo box
        self.stopBits = int(self.cf.get('Coms', 'StopBits')) # index of combo box
        self.outgoing = int(self.cf.get('Coms', 'OutGoing'))
        self.XonXoff = self.cf.getboolean('Coms', 'XonXoff')
        self.RtsCts = self.cf.getboolean('Coms', 'RtsCts')
        self.RTS = self.cf.getboolean('Coms', 'RTS')
        self.DTR = self.cf.getboolean('Coms', 'DTR') # normaqlly high
        self.EOL = int(self.cf.get('Coms', 'Endofline')) # end of line 0..2
        self.quiet = self.cf.getboolean('Coms', 'Quiet')
        self.echo = self.cf.getboolean('Coms', 'Echo')
        self.escmode = self.cf.getboolean('Coms', 'escMode')
        #
        self.filename = self.cf.get('tload', 'filename')
        self.start = self.cf.get('tload', 'start')
        self.upmname = self.cf.get('tload', 'upmname')
        self.upmdup = self.cf.get('tload', 'upmdup')
        self.filename = self.cf.get('tload', 'ffilename')
        #
        self.order = self.cf.get('rgb','order')
        #
        self.flashStart = self.cf.get('boot', 'flashstart')
        self.flashSize = self.cf.get('boot', 'flashsize')
        self.bfileName = self.cf.get('boot', 'bfilename')
        self.verbose = self.cf.get('boot', 'verbose')
        self.eraseDelay = self.cf.get('boot', 'erase')
